#!/usr/bin/env python

"""
This test illustrates the need for propagation of usage to assignments providing
active name definitions.
"""

class C:
    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def f(self):
        return 4

    def h(self):    # unused
        return 5

def test_new(obj, obj2):
    # obj should provide f
    if obj.f():
        obj = obj2  # should provide f, g
        obj.g()
    return obj.f()

c = C()
d = D()
e = E()
result2_2 = test_new(c, d)

# vim: tabstop=4 expandtab shiftwidth=4
